## fcitx 4.2.8.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.6)

project(fcitx)

set(version 4.2.8.5)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
set(CMAKE_AUTOMOC_RELAXED_MODE TRUE)

set_property(GLOBAL PROPERTY "__FCITX_INTERNAL_BUILD" On)

option(ENABLE_X11 "Enable X11 as dependency" ON)
option(ENABLE_GLIB2 "Enable GLib2 as depenedency" ON)
option(ENABLE_CAIRO "Enable Cairo" ON)
option(ENABLE_DBUS "Enable DBus Support" ON)
option(ENABLE_PANGO "Enable Pango Support" ON)
option(ENABLE_LIBXML2 "Enable libxml2" ON)
option(ENABLE_DEBUG "Enable Debug" OFF)
option(ENABLE_PINYIN "Enable Pinyin" ON)
option(ENABLE_TABLE "Enable Table IM" ON)
option(ENABLE_GTK2_IM_MODULE "Enable GTK2 IM Module" ON)
option(ENABLE_GTK3_IM_MODULE "Enable GTK3 IM Module" OFF)
option(ENABLE_QT "Enable Qt-based lib" On)
option(ENABLE_QT_IM_MODULE "Enable Qt IM Module" ON)
option(ENABLE_QT_GUI "Enable Qt-based configuration GUI" On)
option(ENABLE_OPENCC "Enable OpenCC for Chinese Transform" ON)
option(FORCE_OPENCC
  "Enable opencc even if the library is not found at compile time" Off)
option(ENABLE_LUA "Enable Lua support" OFF)
option(ENABLE_STATIC "Build Static Library" OFF)
option(ENABLE_TEST "Test build" OFF)
option(ENABLE_SNOOPER "Enable Key Snooper for gtk app" On)
option(ENABLE_GIR "Enable GObject Introspection" On)
option(ENABLE_ENCHANT "Enable enchant for word predication" On)
option(ENABLE_PRESAGE "Enable presage for word predication" On)
option(FORCE_ENCHANT
  "Enable enchant even if the library is not found at compile time" Off)
option(FORCE_PRESAGE
  "Enable presage even if the library is not found at compile time" Off)
option(ENABLE_ICU "Enable icu for qt/keyboard compose" On)
option(ENABLE_BACKTRACE "Enable backtrace support" On)
option(ENABLE_XDGAUTOSTART "Enable xdg autostart desktop file installion" On)
option(ENABLE_GETTEXT "Enable gettext support." On)

if(NOT NO_SNOOPER_APPS)
  set(NO_SNOOPER_APPS ".*chrome.*,.*chromium.*,firefox.*,Do.*"
    CACHE STRING "Disable Key Snooper for following app")
endif()

if(NOT NO_PREEDIT_APPS)
  set(NO_PREEDIT_APPS "gvim"
    CACHE STRING "Disable Preedit for the following apps")
endif()

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(FindPkgConfig)
include(UseDoxygen OPTIONAL)
include(FcitxMacro)

_fcitx_add_uninstall_target()
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(malloc.h HAVE_MALLOC_H)
check_include_files(stdbool.h HAVE_STDBOOL_H)
check_function_exists(asprintf HAVE_ASPRINTF)

find_package(Libintl REQUIRED)
find_package(Libiconv REQUIRED)
find_package(Pthread REQUIRED)
find_package(Libexecinfo)
find_package(GettextPo)

if(NOT ENABLE_GETTEXT OR NOT GETTEXTPO_FOUND)
  fcitx_disable_gettext()
endif()

if(LIBEXECINFO_LIB_FOUND)
  set(ENABLE_BACKTRACE 1)
else()
  set(ENABLE_BACKTRACE 0)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "BSD")
  find_package(Libkvm REQUIRED)
endif(${CMAKE_SYSTEM_NAME} MATCHES "BSD")
find_package(DL REQUIRED)
if(ENABLE_ENCHANT)
  find_package(Enchant)
  if(NOT (ENCHANT_FOUND OR FORCE_ENCHANT))
    set(ENABLE_ENCHANT Off)
  endif()
endif()
if (ENABLE_LIBXML2)
    find_package(LibXml2 REQUIRED)
    find_package(IsoCodes REQUIRED)
    find_package(XkbFile REQUIRED)
endif (ENABLE_LIBXML2)
if(ENABLE_PRESAGE)
  find_package(Presage)
  if(NOT (PRESAGE_FOUND OR FORCE_PRESAGE))
    set(ENABLE_PRESAGE Off)
  endif()
endif()
if(ENABLE_ICU)
  find_package(ICU REQUIRED)
endif()

if(ENABLE_QT)
  find_package(Qt4 4.5 COMPONENTS QtCore QtGui QtDBus REQUIRED)
endif()

if(ENABLE_X11)
find_package(X11 REQUIRED)

if (NOT X11_Xkb_FOUND)
    message(FATAL_ERROR "Xkb is needed")
endif (NOT X11_Xkb_FOUND)

find_program(some_x_program NAMES iceauth xrdb xterm)
if (NOT some_x_program)
    _pkgconfig_invoke("x11" PC_X11 PREFIX "" "--variable=prefix")
    if (PC_X11_PREFIX)
        set(some_x_program "${PC_X11_PREFIX}/bin/xrdb")
    else (PC_X11_PREFIX)
        set(some_x_program /usr/bin/xrdb)
        message("Warning: Could not determine X binary directory. Assuming /usr/bin.")
    endif (PC_X11_PREFIX)
endif (NOT some_x_program)
get_filename_component(proto_xbindir "${some_x_program}" PATH)
get_filename_component(XBINDIR "${proto_xbindir}" ABSOLUTE)
get_filename_component(xrootdir "${XBINDIR}" PATH)
set(XLIBDIR "${xrootdir}/lib/X11")
endif(ENABLE_X11)

if (ENABLE_TEST)
    ENABLE_TESTING()
endif (ENABLE_TEST)

set(_ENABLE_CAIRO 0)
set(_ENABLE_PANGO 0)
if (ENABLE_X11 AND ENABLE_CAIRO)
    PKG_CHECK_MODULES(CAIRO_XLIB REQUIRED "cairo-xlib>=1.0" )
    if (CAIRO_XLIB_FOUND)
        set(_ENABLE_CAIRO 1)
    endif (CAIRO_XLIB_FOUND)
endif (ENABLE_X11 AND ENABLE_CAIRO)

set(_ENABLE_PANGO 0)
if (_ENABLE_CAIRO AND ENABLE_GLIB2)
    if (ENABLE_PANGO)
        PKG_CHECK_MODULES(PANGOCAIRO "pangocairo>=1.0" )
        if (PANGOCAIRO_FOUND)
            set(_ENABLE_PANGO 1)
        endif (PANGOCAIRO_FOUND)
    endif (ENABLE_PANGO)
    if (NOT _ENABLE_PANGO)
        PKG_CHECK_MODULES(FONTCONFIG REQUIRED "fontconfig")
    endif (NOT _ENABLE_PANGO)
endif(_ENABLE_CAIRO AND ENABLE_GLIB2)

set(_ENABLE_DBUS 0)
if (ENABLE_DBUS)
    PKG_CHECK_MODULES(DBUS "dbus-1>=1.1.0" )
    if (DBUS_FOUND)
        set(_ENABLE_DBUS 1)
    endif (DBUS_FOUND)
endif (ENABLE_DBUS)

if(ENABLE_OPENCC)
    find_package(OpenCC)
    if(NOT (OPENCC_FOUND OR FORCE_OPENCC))
        set(ENABLE_OPENCC Off)
    endif()
endif()

set(HAVE_XINERAMA 0)
if (X11_Xinerama_FOUND)
    set(HAVE_XINERAMA 1)
endif (X11_Xinerama_FOUND)

if (X11_Xfixes_FOUND)
    set(HAVE_XFIXES 1)
endif (X11_Xfixes_FOUND)

if(ENABLE_DEBUG)
    set(_DEBUG ON)
endif(ENABLE_DEBUG)

set(package     fcitx)
set(prefix      ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_PREFIX})
set(bindir ${exec_prefix}/bin)

if(NOT DEFINED LIB_INSTALL_DIR)
    set(LIB_INSTALL_DIR "${exec_prefix}/lib" CACHE PATH "Library install directory [default=PREFIX/lib/]")
endif()
if(NOT DEFINED LIBDATA_INSTALL_DIR)
    set(LIBDATA_INSTALL_DIR "${LIB_INSTALL_DIR}"  CACHE PATH "Lib data install directory [default=LIB_INSTALL_DIR]")
endif()
if(NOT DEFINED MAN_INSTALL_DIR)
    set(MAN_INSTALL_DIR "${prefix}/share/man"  CACHE PATH "man install directory [default=PREFIX/share/man]")
endif()
if (NOT DEFINED DBUS_SERVICE_DIR)
    set(DBUS_SERVICE_DIR "${CMAKE_INSTALL_PREFIX}/share/dbus-1/services" CACHE PATH "dbus session service directory [default=PREFIX/share/dbus-1/services]")
endif()
if (NOT DEFINED SYSCONFDIR)
    set(SYSCONFDIR "${CMAKE_INSTALL_PREFIX}/etc" CACHE PATH "sys config directory [default=PREFIX/etc/]")
endif()

set(includedir "${CMAKE_INSTALL_PREFIX}/include")
set(libdir ${LIB_INSTALL_DIR})
set(pkgconfdir ${LIBDATA_INSTALL_DIR}/pkgconfig)
set(mandir ${MAN_INSTALL_DIR})
set(addondir ${libdir}/${package} )
set(pkgdatadir ${prefix}/share/${package})
set(configdescdir ${pkgdatadir}/configdesc)
set(addonconfigdir ${pkgdatadir}/addon)
set(imconfigdir ${pkgdatadir}/inputmethod)
set(localedir ${CMAKE_INSTALL_PREFIX}/share/locale)

list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" _isSystemPlatformLibDir)
list(FIND CMAKE_CXX_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" _isSystemCxxLibDir)
if("${_isSystemPlatformLibDir}" STREQUAL "-1" AND "${_isSystemCxxLibDir}" STREQUAL "-1")
    set(CMAKE_SKIP_BUILD_RPATH  FALSE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH "${LIB_INSTALL_DIR}")
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif("${_isSystemPlatformLibDir}" STREQUAL "-1" AND "${_isSystemCxxLibDir}" STREQUAL "-1")

# For FcitxMacro
set(FCITX4_ADDON_INSTALL_DIR ${addondir})
set(FCITX4_CONFIGDESC_INSTALL_DIR ${configdescdir})
set(FCITX4_ADDON_CONFIG_INSTALL_DIR ${addonconfigdir})
set(FCITX4_INPUTMETHOD_CONFIG_INSTALL_DIR ${imconfigdir})
set(FCITX4_PACKAGE_NAME ${package})

function(_RESOLVE_LIBRARY_PATH _FILE_NAME _LIBRARY_PATH)
    if (CMAKE_OBJDUMP)
        execute_process (
            COMMAND ${CMAKE_OBJDUMP} -p "${_LIBRARY_PATH}"
            RESULT_VARIABLE STATUS
            OUTPUT_VARIABLE OBJDUMP_RESULT
            ERROR_QUIET
        )
        string(REGEX REPLACE ".*SONAME +([^ ]+)\n.*$" "\\1" SONAME_OUT "${OBJDUMP_RESULT}")
        if (SONAME_OUT)
            set(_FILE_NAME_OUT "${SONAME_OUT}")
        endif ()
    endif()
    if (NOT _FILE_NAME_OUT)
        get_filename_component(_FILE_NAME_OUT "${_LIBRARY_PATH}" NAME)
    endif()
    set(${_FILE_NAME} ${_FILE_NAME_OUT} PARENT_SCOPE)
endfunction()


if (NOT DEFINED OPENCC_LIBRARY_FILENAME)
    if (OPENCC_LIBRARIES)
        _RESOLVE_LIBRARY_PATH(OPENCC_LIBRARY_FILENAME "${OPENCC_LIBRARIES}")
    else ()
        set(OPENCC_LIBRARY_FILENAME
            "${CMAKE_SHARED_LIBRARY_PREFIX}opencc${CMAKE_SHARED_LIBRARY_SUFFIX}")
    endif ()
endif()

if(NOT DEFINED ENCHANT_LIBRARY_FILENAME)
    if (ENCHANT_LIBRARIES)
        _RESOLVE_LIBRARY_PATH(ENCHANT_LIBRARY_FILENAME "${ENCHANT_LIBRARIES}")
    else ()
        set(ENCHANT_LIBRARY_FILENAME
            "${CMAKE_SHARED_LIBRARY_PREFIX}enchant${CMAKE_SHARED_LIBRARY_SUFFIX}")
    endif ()
endif()
if(NOT DEFINED PRESAGE_LIBRARY_FILENAME)
    if (PRESAGE_LIBRARIES)
        _RESOLVE_LIBRARY_PATH(PRESAGE_LIBRARY_FILENAME "${PRESAGE_LIBRARIES}")
    else ()
        set(PRESAGE_LIBRARY_FILENAME
            "${CMAKE_SHARED_LIBRARY_PREFIX}presage${CMAKE_SHARED_LIBRARY_SUFFIX}")
    endif ()
endif()

set(CMAKE_C_FLAGS "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -fvisibility=hidden ${CMAKE_C_FLAGS}")
set(CMAKE_CXX_FLAGS "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -fvisibility=hidden ${CMAKE_CXX_FLAGS}")
set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--as-needed ${CMAKE_SHARED_LINKER_FLAGS}")
set(CMAKE_MODULE_LINKER_FLAGS "-Wl,--as-needed ${CMAKE_MODULE_LINKER_FLAGS}")
add_definitions("-D_GNU_SOURCE -DFCITX_HAVE_CONFIG_H")

configure_file(${PROJECT_SOURCE_DIR}/config.h.in ${PROJECT_BINARY_DIR}/config.h)
configure_file("${PROJECT_SOURCE_DIR}/cmake/FcitxConfigVersion.cmake.in"
               "${PROJECT_BINARY_DIR}/cmake/FcitxConfigVersion.cmake"
                IMMEDIATE @ONLY
)

include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_BINARY_DIR}/src/)
include_directories(${PROJECT_SOURCE_DIR}/src/)
include_directories(${PROJECT_SOURCE_DIR}/src/lib/)

# must be the first
add_subdirectory(po)
add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(skin)
add_subdirectory(tools)
add_subdirectory(data)
add_subdirectory(cmake)

if(ENABLE_TEST)
  add_subdirectory(test)
endif()

=== po/CMakeLists.txt ===
set(PO_LANGS de es ja zh_CN zh_TW ko)
foreach(lang ${PO_LANGS})
  fcitx_translate_add_po_file("${lang}" "${lang}.po")
endforeach()
fcitx_translate_set_pot_target(pot fcitx fcitx.pot)

install(FILES getdescpo DESTINATION share/cmake/fcitx
  PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
  GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

=== src/lib/CMakeLists.txt ===
add_subdirectory(fcitx-config)
add_subdirectory(fcitx-utils)
add_subdirectory(fcitx)
if(_ENABLE_DBUS AND ENABLE_GLIB2)
  PKG_CHECK_MODULES(GIO2 "gio-2.0>=2.26")
endif()
add_subdirectory(fcitx-gclient)
add_subdirectory(fcitx-qt)

=== src/lib/fcitx-gclient/CMakeLists.txt ===
set(FCITX_GCLIENT_SOURCES
  fcitxclient.c
  fcitxinputmethod.c
  fcitxkbd.c
  fcitxconnection.c
  #fcitxdbusproxy.c
  )

set(FCITX_GCLIENT_BUILT_SOURCES
  ${CMAKE_CURRENT_BINARY_DIR}/marshall.c
  )

set(FCITX_GCLIENT_HEADERS
  fcitxclient.h
  fcitxinputmethod.h
  fcitxkbd.h
  #fcitxdbusproxy.h
  fcitxconnection.h
  )

set(FCITX_GCLIENT_BUILT_HEADERS
  ${CMAKE_CURRENT_BINARY_DIR}/marshall.h
  )

fcitx_translate_add_sources(${FCITX_GCLIENT_SOURCES}
  ${FCITX_GCLIENT_HEADERS})

if(NOT (_ENABLE_DBUS AND ENABLE_GLIB2 AND GIO2_FOUND))
  return()
endif()

_pkgconfig_invoke("glib-2.0" GLIB2 GLIB_GENMARSHAL
  "" "--variable=glib_genmarshal")
FIND_PROGRAM(GLIB_GENMARSHAL ${GLIB2_GLIB_GENMARSHAL})

include_directories(${GIO2_INCLUDE_DIRS})
include_directories(${DBUS_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
link_directories(${GIO2_LIBRARY_DIRS})
link_directories(${DBUS_LIBRARY_DIRS})

add_custom_command(OUTPUT marshall.c
  COMMAND ${GLIB_GENMARSHAL} --body --prefix=fcitx_marshall
  ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.c
  DEPENDS ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list)
add_custom_command(OUTPUT marshall.h
  COMMAND ${GLIB_GENMARSHAL} --header --prefix=fcitx_marshall
  ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.h
  DEPENDS ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list)

add_library(fcitx-gclient SHARED ${FCITX_GCLIENT_SOURCES}
  ${FCITX_GCLIENT_BUILT_SOURCES} ${FCITX_GCLIENT_BUILT_HEADERS})
set_target_properties(fcitx-gclient
  PROPERTIES VERSION 0.1
  SOVERSION 0
  COMPILE_FLAGS "-fvisibility=hidden"
  LINK_FLAGS "-Wl,--no-undefined")
target_link_libraries(fcitx-gclient ${GIO2_LIBRARIES}
  ${DBUS_LIBRARIES} fcitx-utils)
configure_file(fcitx-gclient.pc.in ${CMAKE_CURRENT_BINARY_DIR}/fcitx-gclient.pc)

install(TARGETS fcitx-gclient LIBRARY DESTINATION "${libdir}")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fcitx-gclient.pc
  DESTINATION "${pkgconfdir}")
install(FILES ${FCITX_GCLIENT_HEADERS}
  DESTINATION "${includedir}/fcitx-gclient")

if(ENABLE_GIR)
  include(GObjectIntrospection)
  gobject_introspection(
    FILENAME Fcitx-1.0.gir
    NSVERSION 1.0
    INCLUDE Gio-2.0 GObject-2.0 GLib-2.0
    PACKAGE_EXPORT fcitx-gclient
    LIBRARY fcitx-gclient
    SCANNER_ARGS --warn-all --add-include-path=${CMAKE_CURRENT_SOURCE_DIR}
    COMPILER_ARGS "--includedir=${CMAKE_CURRENT_SOURCE_DIR}"
    SYMBOL_PREFIXES fcitx
    SOURCES ${FCITX_GCLIENT_SOURCES} ${FCITX_GCLIENT_HEADERS}
    QUIET
    )
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/Fcitx-1.0.gir"
    DESTINATION "${GOBJECT_INTROSPECTION_GIRDIR}")
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/Fcitx-1.0.typelib"
    DESTINATION "${GOBJECT_INTROSPECTION_TYPELIBDIR}")
endif()

if(ENABLE_STATIC)
  add_library(fcitx-gclient-static STATIC ${FCITX_GCLIENT_SOURCES})
  set_target_properties(fcitx-gclient-static PROPERTIES
    OUTPUT_NAME "fcitx-gclient"
    PREFIX "lib")
  install(TARGETS fcitx-gclient-static
    LIBRARY DESTINATION "${libdir}"
    ARCHIVE DESTINATION "${libdir}")
endif()

add_subdirectory(test)

=== src/module/punc/CMakeLists.txt ===
set(FCITX_PUNC_SOURCES
  punc.c)
fcitx_add_addon_full(punc SCAN SCAN_PRIV
  SOURCES ${FCITX_PUNC_SOURCES}
  HEADERS punc.h)

=== src/module/remote/CMakeLists.txt ===
set(FCITX_REMOTE_SOURCES
  remote.c)
fcitx_add_addon_full(remote-module
  SOURCES ${FCITX_REMOTE_SOURCES})

=== src/module/xkbdbus/CMakeLists.txt ===
set(FCITX_XKBDBUS_LINK_LIBS)
if(_ENABLE_XKBDBUS)
  include_directories(
    ${DBUS_INCLUDE_DIRS}
    ${LIBXML2_INCLUDE_DIR})
  set(FCITX_XKBDBUS_LINK_LIBS ${FCITX_XKBDBUS_LINK_LIBS}
    ${DBUS_LIBRARIES} ${LIBXML2_LIBRARIES})
  link_directories(${DBUS_LIBRARY_DIRS})
  set(xkbdbus_noinstall)
else()
  set(xkbdbus_noinstall NO_INSTALL)
endif()

set(FCITX_XKBDBUS_SOURCES
  xkbdbus.c
  ../../im/keyboard/isocodes.c)
fcitx_add_addon_full(xkbdbus ${xkbdbus_noinstall}
  SOURCES ${FCITX_XKBDBUS_SOURCES}
  LINK_LIBS ${FCITX_XKBDBUS_LINK_LIBS})

=== debian/changelog ===
fcitx (1:4.2.8.5-6ubuntu3) vivid; urgency=medium

  * debian/patches/add-kf5-kcm-support.patch:
    - Upstream patch for KF5 KCM support

 -- Aron Xu <happyaron@ubuntu.com>  Thu, 26 Mar 2015 04:38:24 +0800

fcitx (1:4.2.8.5-6ubuntu2) vivid; urgency=medium

  * Add conffile handling for LP: #1431257.

 -- Aron Xu <happyaron@ubuntu.com>  Sat, 14 Mar 2015 09:27:53 +0800

fcitx (1:4.2.8.5-6ubuntu1) vivid; urgency=medium

  * Avoid unwanted autostart (LP: #1431257)

 -- Aron Xu <happyaron@ubuntu.com>  Fri, 13 Mar 2015 05:25:02 +0800

fcitx (1:4.2.8.5-6) experimental; urgency=medium

  * Remove empty lines
  * Add libpresage1 to Depends of fcitx-modules

 -- Aron Xu <aron@debian.org>  Thu, 12 Feb 2015 15:26:49 +0800

fcitx (1:4.2.8.5-5) experimental; urgency=medium

  * Declare fcitx-libs-* packages as transitional
  * Move table files to arch:all
  * Remove NoDisplay patch
  * Update dep5 link in debian/copyright

 -- Aron Xu <aron@debian.org>  Sun, 08 Feb 2015 22:51:37 +0800

fcitx (1:4.2.8.5-4) experimental; urgency=low

  * Add proper Breaks and Replaces (LP: #1387382)

 -- Aron Xu <aron@debian.org>  Thu, 30 Oct 2014 07:22:35 +0800

fcitx (1:4.2.8.5-3) experimental; urgency=low

  * Add libfcitx-core0, libfcitx-config4, libfcitx-utils0, libfcitx-qt0, and
    libfcitx-gclient0, existing fcitx-libs-* package are now metapackages.
  * Update symbols file for libraries.
  * Detect for GIR MultiArch status (Closes: #762832)
  * Enable all hardening features.
  * Enable parallel build.
  * Disable building of static libraries.
  * Update copyright file for better standard compliance.
  * Std-ver: 3.9.5 -> 3.9.6

 -- Aron Xu <aron@debian.org>  Sun, 26 Oct 2014 02:21:19 +0800

fcitx (1:4.2.8.5-1) unstable; urgency=low

  * New upstream release.
  * 0004-implement-set-im-by-name-if-there-is-no-focused-wind.patch:
    - Dropped, merged upstream.

 -- Aron Xu <aron@debian.org>  Sat, 20 Sep 2014 05:10:52 +0800

fcitx (1:4.2.8.4-3) unstable; urgency=medium

  * 0004-implement-set-im-by-name-if-there-is-no-focused-wind.patch:
    - if the focus comes back to the original ic, the im will be set
      eventually. this can be useful if GUI switcher grab the focus.

 -- Aron Xu <aron@debian.org>  Sat, 23 Aug 2014 13:50:50 +0800

fcitx (1:4.2.8.4-2) unstable; urgency=medium

  * Fix FTBFS with GCC 4.9 (Closes: #746844)
  * Force to use opencc

 -- Aron Xu <aron@debian.org>  Mon, 02 Jun 2014 00:04:38 +0800

fcitx (1:4.2.8.4-1) unstable; urgency=low

  * New upstream bug fix release

 -- Aron Xu <aron@debian.org>  Thu, 29 May 2014 17:40:38 +0800

=== debian/control ===
# debian/control is generated automatically from control.in by running the clean target
Source: fcitx
Section: utils
Priority: optional
Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
Uploaders: Aron Xu <aron@debian.org>, YunQiang Su <wzssyqa@gmail.com>
Build-Depends: cmake,
               debhelper (>= 9),
               gobject-introspection,
               iso-codes,
               libcairo2-dev (>= 1.0),
               libdbus-1-dev (>= 1.1.0),
               libenchant-dev,
               libgettextpo-dev,
               libgirepository1.0-dev,
               libgtk-3-dev,
               libgtk2.0-dev,
               libicu-dev,
               libkvm-dev [kfreebsd-any],
               liblua5.2-dev | liblua5.1-0-dev,
               libopencc-dev (>= 0.1.1~),
               libpango1.0-dev (>= 1.0),
               libpresage-dev,
               libpthread-stubs0-dev,
               libqt4-dev,
               libxfixes-dev,
               libxkbfile-dev,
               libxml2-dev,
               x11proto-xinerama-dev
Standards-Version: 3.9.6
Homepage: http://code.google.com/p/fcitx/
Vcs-Git: git://anonscm.debian.org/pkg-ime/fcitx.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ime/fcitx.git

Package: fcitx
Architecture: all
Depends: fcitx-bin, fcitx-data, fcitx-modules, ${misc:Depends}
Recommends: fcitx-config-gtk | kde-config-fcitx,
            fcitx-frontend-all | fcitx-frontend-fbterm,
            fcitx-ui-classic | fcitx-ui-light,
            im-config (>= 0.5) | im-switch
Suggests: fcitx-m17n, fcitx-tools
Description: Flexible Input Method Framework
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This metapackage pulls in a set of components recommended for most desktop
 users.

Package: fcitx-bin
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: fcitx-data, fcitx-modules
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version})
Breaks: fcitx (<< ${source:Upstream-Version})
Description: Flexible Input Method Framework - essential binaries
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the essential executable binaries. If you are
 looking for a working input experience, please install the package
 "fcitx" instead.

Package: fcitx-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: fcitx-bin
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version})
Breaks: fcitx (<< ${source:Upstream-Version})
Description: Flexible Input Method Framework - essential data files
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the essential data files. If you are looking for a
 working input experience, please install the package "fcitx" instead.

Package: fcitx-libs
Architecture: all
Section: oldlibs
Depends: libfcitx-config4 (>= ${source:Version}),
         libfcitx-core0 (>= ${source:Version}),
         libfcitx-utils0 (>= ${source:Version}),
         ${misc:Depends}
Recommends: libfcitx-gclient0 (>= ${source:Version}),
            libfcitx-qt0 (>= ${source:Version}),
            libopencc1 (>= 0.3.0)
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version})
Breaks: fcitx (<< ${source:Upstream-Version})
Description: transitional dummy package
 This is a transitional dummy package. It can safely be removed.

Package: libfcitx-config4
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
Breaks: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
Description: Flexible Input Method Framework - configuration support library
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package contains the library file:
  * libfcitx-config - support library for Fcitx configurations

Package: libfcitx-core0
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
Breaks: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
Description: Flexible Input Method Framework - library of core funtions
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package contains the library file:
  * libfcitx-core - core functions of Fcitx

Package: libfcitx-utils0
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
Breaks: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
Description: Flexible Input Method Framework - utility support library
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package contains the library file:
  * libfcitx-utils - utility support library for Fcitx

Package: fcitx-libs-gclient
Architecture: all
Section: oldlibs
Depends: libfcitx-gclient0 (>= ${source:Version}), ${misc:Depends}
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.7)
Breaks: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.7)
Description: transitional dummy package
 This is a transitional dummy package. It can safely be removed.

Package: libfcitx-gclient0
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version}),
          fcitx-libs-gclient (<< 1:4.2.8.5-3)
Breaks: fcitx (<< ${source:Upstream-Version}),
        fcitx-libs-gclient (<< 1:4.2.8.5-3)
Description: Flexible Input Method Framework - D-Bus client library for Glib
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package contains the following library:
  * libfcitx-gclient - D-Bus client library for Glib

Package: fcitx-libs-qt
Architecture: all
Section: oldlibs
Depends: libfcitx-qt0 (>= ${source:Version}), ${misc:Depends}
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.7)
Breaks: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.7)
Description: transitional dummy package
 This is a transitional dummy package. It can safely be removed.

Package: libfcitx-qt0
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version}), fcitx-libs-qt (<< 1:4.2.8.5-3)
Breaks: fcitx (<< ${source:Upstream-Version}), fcitx-libs-qt (<< 1:4.2.8.5-3)
Description: Flexible Input Method Framework - Meta package for Qt library
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package contains the following library:
  * libfcitx-qt - D-Bus client library for Qt

Package: fcitx-libs-dev
Architecture: any
Section: libdevel
Depends: fcitx-bin (>= ${source:Version}),
         libfcitx-config4 (= ${binary:Version}),
         libfcitx-core0 (= ${binary:Version}),
         libfcitx-gclient0 (= ${binary:Version}),
         libfcitx-qt0 (= ${binary:Version}),
         libfcitx-utils0 (= ${binary:Version}),
         ${misc:Depends}
Replaces: fcitx (<< ${source:Upstream-Version})
Breaks: fcitx (<< ${source:Upstream-Version})
Description: Flexible Input Method Framework - library development files
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the library development files.

Package: gir1.2-fcitx-1.0
Architecture: any
Section: introspection
Depends: ${gir:Depends}, ${misc:Depends}
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version})

=== debian/rules ===
#!/usr/bin/make -f
include debian/variables.mk
include debian/gencontrol.mk
%:
	dh $@ --parallel --with gir
override_dh_auto_clean: gen_control
	dh_auto_clean
override_dh_auto_configure: gen_control
	dh_auto_configure -- \
	    -DCMAKE_BUILD_TYPE=Release \
	    -DLIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
	    -DSYSCONFDIR=/etc \
	    -DENABLE_X11=ON \
	    -DENABLE_GLIB2=ON \
	    -DENABLE_CAIRO=ON \
	    -DENABLE_DBUS=ON \
	    -DENABLE_PANGO=ON \
	    -DENABLE_LIBXML2=ON \
	    -DENABLE_DEBUG=OFF \
	    -DENABLE_PINYIN=ON \
	    -DENABLE_TABLE=ON \
	    -DENABLE_GTK2_IM_MODULE=ON \
	    -DENABLE_GTK3_IM_MODULE=ON \
	    -DENABLE_QT=ON \
	    -DENABLE_QT_IM_MODULE=ON \
	    -DENABLE_QT_GUI=ON \
	    -DFORCE_OPENCC=ON \
	    -DENABLE_LUA=ON \
	    -DENABLE_STATIC=OFF \
	    -DENABLE_TEST=ON \
	    -DENABLE_SNOOPER=ON \
	    -DENABLE_GIR=ON \
	    -DENABLE_ENCHANT=ON \
	    -DENABLE_PRESAGE=ON \
	    -DENABLE_ICU=ON \
	    -DENABLE_BACKTRACE=ON \
	    -DENABLE_XDGAUTOSTART=ON \
	    -DENABLE_GETTEXT=ON
override_dh_install:
	dh_install --fail-missing
override_dh_makeshlibs:
	dh_makeshlibs -plibfcitx-core0
	dh_makeshlibs -plibfcitx-config4
	dh_makeshlibs -plibfcitx-utils0
	dh_makeshlibs -plibfcitx-qt0
	dh_makeshlibs -plibfcitx-gclient0
override_dh_strip:
	dh_strip --dbg-package=fcitx-dbg

## fcitx 4.2.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,12 @@
-cmake_minimum_required(VERSION 2.8.6)
+cmake_minimum_required(VERSION 2.8.12)
 
 project(fcitx)
 
-set(version 4.2.8.5)
-
-set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
+set(version 4.2.9)
+
+
+find_package(ECM 0.0.11 REQUIRED NO_MODULE)
+set(CMAKE_MODULE_PATH "${ECM_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
 set(CMAKE_AUTOMOC_RELAXED_MODE TRUE)
 
 set_property(GLOBAL PROPERTY "__FCITX_INTERNAL_BUILD" On)
@@ -69,6 +71,7 @@
 find_package(Pthread REQUIRED)
 find_package(Libexecinfo)
 find_package(GettextPo)
+find_package(XKBCommon 0.5.0 REQUIRED COMPONENTS XKBCommon)
 
 if(NOT ENABLE_GETTEXT OR NOT GETTEXTPO_FOUND)
   fcitx_disable_gettext()
@@ -100,9 +103,6 @@
   if(NOT (PRESAGE_FOUND OR FORCE_PRESAGE))
     set(ENABLE_PRESAGE Off)
   endif()
-endif()
-if(ENABLE_ICU)
-  find_package(ICU REQUIRED)
 endif()
 
 if(ENABLE_QT)

=== debian/changelog ===
fcitx (1:4.2.9-3) unstable; urgency=medium

  * Add conffile handling

 -- Aron Xu <aron@debian.org>  Wed, 23 Sep 2015 22:36:14 +0800

fcitx (1:4.2.9-2) unstable; urgency=medium

  * Move .desktop file to avoid unexpected autostart

 -- Aron Xu <aron@debian.org>  Sun, 20 Sep 2015 17:52:24 +0800

fcitx (1:4.2.9-1) unstable; urgency=medium

  * New upstream release

 -- Aron Xu <aron@debian.org>  Wed, 03 Jun 2015 04:08:45 +0800

=== debian/control ===
--- 
+++ 
@@ -6,10 +6,11 @@
 Uploaders: Aron Xu <aron@debian.org>, YunQiang Su <wzssyqa@gmail.com>
 Build-Depends: cmake,
                debhelper (>= 9),
+               extra-cmake-modules,
                gobject-introspection,
                iso-codes,
+               qtbase5-dev,
                libcairo2-dev (>= 1.0),
-               libdbus-1-dev (>= 1.1.0),
                libenchant-dev,
                libgettextpo-dev,
                libgirepository1.0-dev,
@@ -21,10 +22,9 @@
                libopencc-dev (>= 0.1.1~),
                libpango1.0-dev (>= 1.0),
                libpresage-dev,
-               libpthread-stubs0-dev,
                libqt4-dev,
-               libxfixes-dev,
                libxkbfile-dev,
+               libxkbcommon-dev (>= 0.5.0~),
                libxml2-dev,
                x11proto-xinerama-dev
 Standards-Version: 3.9.6
